#ifndef __vtkCORIEUnstructuredGridReader_h
#define __vtkCORIEUnstructuredGridReader_h

#include "vtkUnstructuredGridReader.h"
#include "vtkCollection.h"
#include "vtkPoints.h"
#include "vtkContourGrid.h"

class VTK_IO_EXPORT vtkCORIEUnstructuredGridReader : public vtkUnstructuredGridReader {
public:
  static vtkCORIEUnstructuredGridReader *New();
  vtkTypeRevisionMacro(vtkCORIEUnstructuredGridReader, vtkUnstructuredGridReader);
  void PrintSelf(ostream& os, vtkIndent indent);

  vtkSetMacro(VerticalScale, double);	
  vtkGetMacro(VerticalScale, double);
  
  vtkSetMacro(VerticalShift, double);	
  vtkGetMacro(VerticalShift, double);
  
  vtkSetMacro(TimeStep, int);
  vtkGetMacro(TimeStep, int);

  vtkSetMacro(FromLayer, int);
  vtkGetMacro(FromLayer, int);
  vtkSetMacro(ToLayer, int);
  vtkGetMacro(ToLayer, int);

protected:
  vtkCORIEUnstructuredGridReader();
  ~vtkCORIEUnstructuredGridReader();

  virtual int RequestData(vtkInformation *, vtkInformationVector **,
						  vtkInformationVector *);

  vtkUnstructuredGrid *ReadTimeStep(vtkUnstructuredGrid *ugrid, char *fileName);
  vtkUnstructuredGrid *ReadUGrid(vtkUnstructuredGrid *ugrid, const char *fname);  
  
  double VerticalScale;
  double VerticalShift;
  int TimeStep;
  int FromLayer;
  int ToLayer;

private:
  vtkCORIEUnstructuredGridReader(const vtkCORIEUnstructuredGridReader&);  // Not implemented.
  void operator=(const vtkCORIEUnstructuredGridReader&);  // Not implemented.
};

#endif


